/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: JmsBC.java 676 2006-06-27 15:44:03Z alouis $
 * -------------------------------------------------------------------------
 */

package org.ow2.petals.bc.jms;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

import org.apache.commons.pool.impl.GenericObjectPool;
import org.ow2.petals.bc.jms.su.JmsServiceUnitListener;
import org.ow2.petals.component.framework.bc.AbstractBindingComponent;
import org.ow2.petals.jbi.descriptor.Provides;

/**
 * This component is a JMS BC
 *
 * @author alouis - eBMWebsourcing
 */
public class JmsBC extends AbstractBindingComponent {

    /**
     * Contains JMSProviderConnection pool, stored by 'provides' (ie provided
     * endpoints)
     */
    private Map<Provides, GenericObjectPool> jmsProducerConnections;

    @Override
    protected void doInit() {
        this.jmsProducerConnections = Collections
                .synchronizedMap(new HashMap<Provides, GenericObjectPool>());
        setServiceUnitListener(new JmsServiceUnitListener(this));
    }

    public Map<Provides, GenericObjectPool> getJmsProducerConnections() {
        return jmsProducerConnections;
    }

}
