
package org.ow2.petals.bc.jms.connection;

import javax.jms.JMSException;
import javax.jms.JMSSecurityException;
import javax.jms.MessageConsumer;
import javax.naming.Context;

import org.ow2.petals.component.framework.exception.TechnicalException;

public class JMSConsumerConnection extends AbstractJMSConnection {

    private MessageConsumer messageConsumer;

    public JMSConsumerConnection(Context jndiContext,
            String connectionFactoryName, String destinationName,
            boolean transacted, String user, String password) {
        super(jndiContext, connectionFactoryName, destinationName, transacted,
                user, password);
    }

    public void createJMSConsumerOrProducer() throws TechnicalException {
        try {
            this.messageConsumer = this.session
                    .createConsumer(this.destination);
        } catch (JMSSecurityException e) {
            throw new TechnicalException(
                    "Can not start JMS consumer, READ right not granted.", e);
        } catch (JMSException e) {
            throw new TechnicalException(
                    "Cannot create JMS consumer for destination : "
                            + destination, e);
        }
    }

    public MessageConsumer getMessageConsumer() {
        return messageConsumer;
    }
}
