
package org.ow2.petals.bc.jms.connection;

import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.naming.Context;

import org.ow2.petals.component.framework.exception.TechnicalException;

public class JMSProviderConnection extends AbstractJMSConnection {

    private MessageProducer messageProducer;

    public JMSProviderConnection(Context jndiContext,
            String connectionFactoryName, String destinationName,
            boolean transacted, String user, String password) {
        super(jndiContext, connectionFactoryName, destinationName, transacted,
                user, password);
    }

    public void createJMSConsumerOrProducer() throws TechnicalException {
        try {
            this.messageProducer = this.session
                    .createProducer(this.destination);
        } catch (JMSException e) {
            throw new TechnicalException(
                    "Cannot create message producer for destination : "
                            + destination, e);
        }
    }

    public MessageProducer getMessageProducer() {
        return messageProducer;
    }

}
