
package org.ow2.petals.bc.jms.listener;

import java.util.logging.Level;

import javax.jbi.messaging.Fault;

import org.ow2.petals.component.framework.exception.PEtALSCDKException;
import org.ow2.petals.component.framework.exception.TechnicalException;
import org.ow2.petals.component.framework.listener.AbstractJBIListener;
import org.ow2.petals.component.framework.util.Exchange;
import org.ow2.petals.component.framework.util.SourceHelper;

public class FaultManager {
    private AbstractJBIListener listener;

    public FaultManager(AbstractJBIListener listener) {
        super();
        this.listener = listener;
    }

    public void onJBIMessage(Exchange exchange) throws TechnicalException {
        // Simply log Fault
        Fault fault = exchange.getFault();
        try {
            listener.getLogger().log(
                    Level.INFO,
                    "JMS BC receive a Fault from an other component : \n"
                            + SourceHelper.createString(fault.getContent()));
        } catch (PEtALSCDKException e) {
            throw new TechnicalException(
                    "Error logging fault received on JMS BC", e);
        }
    }
}
