
package org.ow2.petals.bc.jms.listener;

import java.util.logging.Level;

import javax.jbi.messaging.MessageExchange;

import org.ow2.petals.component.framework.exception.TechnicalException;
import org.ow2.petals.component.framework.listener.AbstractJBIListener;
import org.ow2.petals.component.framework.util.Exchange;

public class JBIListener extends AbstractJBIListener {

    private FaultManager faultManager;

    private ResponseManager responseManager;

    private ServiceManager serviceManager;

    @Override
    protected void init() {
        // Create ServiceManager, ResponseManager and FaultManager here
        faultManager = new FaultManager(this);
        responseManager = new ResponseManager(this);
        serviceManager = new ServiceManager(this);
    }

    @Override
    protected void onJBIMessage(Exchange exchange) {
        getLogger().log(Level.FINE, "onJBIMessage");
        try {
            if (exchange.getFault() != null) {
                faultManager.onJBIMessage(exchange);
            } else if (MessageExchange.Role.CONSUMER.equals(exchange.getRole())) {
                responseManager.onJBIMessage(exchange);
            } else {
                serviceManager.onJBIMessage(exchange);
            }
        } catch (TechnicalException e) {
            getLogger().log(Level.SEVERE, e.getMessage(), e);
            exchange.setError(new Exception(e.getMessage()));
        }
    }

}
