
package org.ow2.petals.bc.jms.listener;

import java.util.logging.Level;

import javax.jbi.messaging.MessagingException;

import org.ow2.petals.component.framework.exception.TechnicalException;
import org.ow2.petals.component.framework.listener.AbstractJBIListener;
import org.ow2.petals.component.framework.util.Exchange;

public class ResponseManager {

    private AbstractJBIListener listener;

    public ResponseManager(AbstractJBIListener listener) {
        super();
        this.listener = listener;
    }

    public void onJBIMessage(Exchange exchange) throws TechnicalException {
        // Simply log Response content
        try {
            listener.getLogger().log(
                    Level.INFO,
                    "JMS BC receive a response from an other component : \n"
                            + exchange.getOutMessageContentAsString());
        } catch (MessagingException e) {
            throw new TechnicalException(
                    "Error logging Response received on JMS BC", e);
        }

    }
}
